# 1 "/Users/keith/.platformio/packages/framework-arduinoststm32-maple/STM32F1/cores/maple/libmaple/usb/usb_lib/usb_mem.c"
# 1 "/Users/keith/Desktop/Marlin/Marlin-issue_tevo_nereus//"
# 1 "<built-in>"
# 1 "<command-line>"
# 1 "/Users/keith/.platformio/packages/framework-arduinoststm32-maple/STM32F1/cores/maple/libmaple/usb/usb_lib/usb_mem.c"
# 17 "/Users/keith/.platformio/packages/framework-arduinoststm32-maple/STM32F1/cores/maple/libmaple/usb/usb_lib/usb_mem.c"
# 1 "/Users/keith/.platformio/packages/framework-arduinoststm32-maple/STM32F1/system/libmaple/usb/usb_lib/usb_lib.h" 1
# 21 "/Users/keith/.platformio/packages/framework-arduinoststm32-maple/STM32F1/system/libmaple/usb/usb_lib/usb_lib.h"
# 1 "/Users/keith/.platformio/packages/framework-arduinoststm32-maple/STM32F1/system/libmaple/usb/usb_lib/usb_type.h" 1
# 30 "/Users/keith/.platformio/packages/framework-arduinoststm32-maple/STM32F1/system/libmaple/usb/usb_lib/usb_type.h"
typedef signed long s32;
typedef signed short s16;
typedef signed char s8;

typedef volatile signed long vs32;
typedef volatile signed short vs16;
typedef volatile signed char vs8;

typedef unsigned long u32;
typedef unsigned short u16;
typedef unsigned char u8;

typedef unsigned long const uc32;
typedef unsigned short const uc16;
typedef unsigned char const uc8;

typedef volatile unsigned long vu32;
typedef volatile unsigned short vu16;
typedef volatile unsigned char vu8;

typedef volatile unsigned long const vuc32;
typedef volatile unsigned short const vuc16;
typedef volatile unsigned char const vuc8;


typedef enum
{
  FALSE = 0, TRUE = !FALSE
}
USB_Bool;

typedef enum { RESET = 0, SET = !RESET } FlagStatus, ITStatus;

typedef enum { DISABLE = 0, ENABLE = !DISABLE} FunctionalState;
# 22 "/Users/keith/.platformio/packages/framework-arduinoststm32-maple/STM32F1/system/libmaple/usb/usb_lib/usb_lib.h" 2
# 1 "/Users/keith/.platformio/packages/framework-arduinoststm32-maple/STM32F1/system/libmaple/usb/usb_lib/usb_regs.h" 1
# 26 "/Users/keith/.platformio/packages/framework-arduinoststm32-maple/STM32F1/system/libmaple/usb/usb_lib/usb_regs.h"
typedef enum _EP_DBUF_DIR
{

  EP_DBUF_ERR,
  EP_DBUF_OUT,
  EP_DBUF_IN
}EP_DBUF_DIR;


enum EP_BUF_NUM
{
  EP_NOBUF,
  EP_BUF0,
  EP_BUF1
};
# 558 "/Users/keith/.platformio/packages/framework-arduinoststm32-maple/STM32F1/system/libmaple/usb/usb_lib/usb_regs.h"
extern volatile u16 wIstr;


void SetCNTR(u16 );
void SetISTR(u16 );
void SetDADDR(u16 );
void SetBTABLE(u16 );
u16 GetCNTR(void);
u16 GetISTR(void);
u16 GetFNR(void);
u16 GetDADDR(void);
u16 GetBTABLE(void);
void SetENDPOINT(u8 , u16 );
u16 GetENDPOINT(u8 );
void SetEPType(u8 , u16 );
u16 GetEPType(u8 );
void SetEPTxStatus(u8 , u16 );
void SetEPRxStatus(u8 , u16 );
void SetDouBleBuffEPStall(u8 , u8 bDir);
u16 GetEPTxStatus(u8 );
u16 GetEPRxStatus(u8 );
void SetEPTxValid(u8 );
void SetEPRxValid(u8 );
u16 GetTxStallStatus(u8 );
u16 GetRxStallStatus(u8 );
void SetEP_KIND(u8 );
void ClearEP_KIND(u8 );
void Set_Status_Out(u8 );
void Clear_Status_Out(u8 );
void SetEPDoubleBuff(u8 );
void ClearEPDoubleBuff(u8 );
void ClearEP_CTR_RX(u8 );
void ClearEP_CTR_TX(u8 );
void ToggleDTOG_RX(u8 );
void ToggleDTOG_TX(u8 );
void ClearDTOG_RX(u8 );
void ClearDTOG_TX(u8 );
void SetEPAddress(u8 , u8 );
u8 GetEPAddress(u8 );
void SetEPTxAddr(u8 , u16 );
void SetEPRxAddr(u8 , u16 );
u16 GetEPTxAddr(u8 );
u16 GetEPRxAddr(u8 );
void SetEPCountRxReg(u32 * , u16 );
void SetEPTxCount(u8 , u16 );
void SetEPRxCount(u8 , u16 );
u16 GetEPTxCount(u8 );
u16 GetEPRxCount(u8 );
void SetEPDblBuf0Addr(u8 , u16 );
void SetEPDblBuf1Addr(u8 , u16 );
void SetEPDblBuffAddr(u8 , u16 , u16 );
u16 GetEPDblBuf0Addr(u8 );
u16 GetEPDblBuf1Addr(u8 );
void SetEPDblBuffCount(u8 , u8 , u16 );
void SetEPDblBuf0Count(u8 , u8 , u16 );
void SetEPDblBuf1Count(u8 , u8 , u16 );
u16 GetEPDblBuf0Count(u8 );
u16 GetEPDblBuf1Count(u8 );
EP_DBUF_DIR GetEPDblBufDir(u8 );
void FreeUserBuffer(u8 bEpNum , u8 bDir);
u16 ToWord(u8, u8);
u16 ByteSwap(u16);
# 23 "/Users/keith/.platformio/packages/framework-arduinoststm32-maple/STM32F1/system/libmaple/usb/usb_lib/usb_lib.h" 2
# 1 "/Users/keith/.platformio/packages/framework-arduinoststm32-maple/STM32F1/system/libmaple/usb/usb_lib/usb_def.h" 1
# 26 "/Users/keith/.platformio/packages/framework-arduinoststm32-maple/STM32F1/system/libmaple/usb/usb_lib/usb_def.h"
typedef enum _RECIPIENT_TYPE
{
  DEVICE_RECIPIENT,
  INTERFACE_RECIPIENT,
  ENDPOINT_RECIPIENT,
  OTHER_RECIPIENT
} RECIPIENT_TYPE;


typedef enum _STANDARD_REQUESTS
{
  GET_STATUS = 0,
  CLEAR_FEATURE,
  RESERVED1,
  SET_FEATURE,
  RESERVED2,
  SET_ADDRESS,
  GET_DESCRIPTOR,
  SET_DESCRIPTOR,
  GET_CONFIGURATION,
  SET_CONFIGURATION,
  GET_INTERFACE,
  SET_INTERFACE,
  TOTAL_sREQUEST,
  SYNCH_FRAME = 12
} STANDARD_REQUESTS;


typedef enum _DESCRIPTOR_TYPE
{
  DEVICE_DESCRIPTOR = 1,
  CONFIG_DESCRIPTOR,
  STRING_DESCRIPTOR,
  INTERFACE_DESCRIPTOR,
  ENDPOINT_DESCRIPTOR
} DESCRIPTOR_TYPE;


typedef enum _FEATURE_SELECTOR
{
  ENDPOINT_STALL,
  DEVICE_REMOTE_WAKEUP
} FEATURE_SELECTOR;
# 24 "/Users/keith/.platformio/packages/framework-arduinoststm32-maple/STM32F1/system/libmaple/usb/usb_lib/usb_lib.h" 2
# 1 "/Users/keith/.platformio/packages/framework-arduinoststm32-maple/STM32F1/system/libmaple/usb/usb_lib/usb_core.h" 1
# 26 "/Users/keith/.platformio/packages/framework-arduinoststm32-maple/STM32F1/system/libmaple/usb/usb_lib/usb_core.h"
typedef enum _CONTROL_STATE
{
  WAIT_SETUP,
  SETTING_UP,
  IN_DATA,
  OUT_DATA,
  LAST_IN_DATA,
  LAST_OUT_DATA,
  WAIT_STATUS_IN,
  WAIT_STATUS_OUT,
  STALLED,
  PAUSE
} CONTROL_STATE;

typedef struct OneDescriptor
{
  u8 *Descriptor;
  u16 Descriptor_Size;
}
ONE_DESCRIPTOR, *PONE_DESCRIPTOR;



typedef enum _RESULT
{
  USB_SUCCESS = 0,
  USB_ERROR,
  USB_UNSUPPORT,
  USB_NOT_READY

} RESULT;



typedef struct _ENDPOINT_INFO
{
# 84 "/Users/keith/.platformio/packages/framework-arduinoststm32-maple/STM32F1/system/libmaple/usb/usb_lib/usb_core.h"
  u16 Usb_wLength;
  u16 Usb_wOffset;
  u16 PacketSize;
  u8 *(*CopyData)(u16 Length);
}ENDPOINT_INFO;



typedef struct _DEVICE
{
  u8 Total_Endpoint;
  u8 Total_Configuration;
}
DEVICE;

typedef union
{
  u16 w;
  struct BW
  {

    u8 bb0;
 u8 bb1;
  }
  bw;
} u16_u8;

typedef struct _DEVICE_INFO
{
  u8 USBbmRequestType;
  u8 USBbRequest;
  u16_u8 USBwValues;
  u16_u8 USBwIndexs;
  u16_u8 USBwLengths;

  u8 ControlState;
  u8 Current_Feature;
  u8 Current_Configuration;
  u8 Current_Interface;
  u8 Current_AlternateSetting;


  ENDPOINT_INFO Ctrl_Info;
}DEVICE_INFO;

typedef struct _DEVICE_PROP
{
  void (*Init)(void);
  void (*Reset)(void);


  void (*Process_Status_IN)(void);
  void (*Process_Status_OUT)(void);
# 154 "/Users/keith/.platformio/packages/framework-arduinoststm32-maple/STM32F1/system/libmaple/usb/usb_lib/usb_core.h"
  RESULT (*Class_Data_Setup)(u8 RequestNo);
# 165 "/Users/keith/.platformio/packages/framework-arduinoststm32-maple/STM32F1/system/libmaple/usb/usb_lib/usb_core.h"
  RESULT (*Class_NoData_Setup)(u8 RequestNo);
# 175 "/Users/keith/.platformio/packages/framework-arduinoststm32-maple/STM32F1/system/libmaple/usb/usb_lib/usb_core.h"
  RESULT (*Class_Get_Interface_Setting)(u8 Interface, u8 AlternateSetting);

  u8* (*GetDeviceDescriptor)(u16 Length);
  u8* (*GetConfigDescriptor)(u16 Length);
  u8* (*GetStringDescriptor)(u16 Length);

  u8* RxEP_buffer;
  u8 MaxPacketSize;

}DEVICE_PROP;

typedef struct _USER_STANDARD_REQUESTS
{
  void (*User_GetConfiguration)(void);
  void (*User_SetConfiguration)(void);
  void (*User_GetInterface)(void);
  void (*User_SetInterface)(void);
  void (*User_GetStatus)(void);
  void (*User_ClearFeature)(void);
  void (*User_SetEndPointFeature)(void);
  void (*User_SetDeviceFeature)(void);
  void (*User_SetDeviceAddress)(void);
}
USER_STANDARD_REQUESTS;
# 220 "/Users/keith/.platformio/packages/framework-arduinoststm32-maple/STM32F1/system/libmaple/usb/usb_lib/usb_core.h"
u8 Setup0_Process(void);
u8 Post0_Process(void);
u8 Out0_Process(void);
u8 In0_Process(void);

RESULT Standard_SetEndPointFeature(void);
RESULT Standard_SetDeviceFeature(void);

u8 *Standard_GetConfiguration(u16 Length);
RESULT Standard_SetConfiguration(void);
u8 *Standard_GetInterface(u16 Length);
RESULT Standard_SetInterface(void);
u8 *Standard_GetDescriptorData(u16 Length, PONE_DESCRIPTOR pDesc);

u8 *Standard_GetStatus(u16 Length);
RESULT Standard_ClearFeature(void);
void SetDeviceAddress(u8);
void NOP_Process(void);

extern DEVICE_PROP Device_Property;
extern USER_STANDARD_REQUESTS User_Standard_Requests;
extern DEVICE Device_Table;
extern DEVICE_INFO Device_Info;


extern u16 SaveRState;
extern u16 SaveTState;
# 25 "/Users/keith/.platformio/packages/framework-arduinoststm32-maple/STM32F1/system/libmaple/usb/usb_lib/usb_lib.h" 2
# 1 "/Users/keith/.platformio/packages/framework-arduinoststm32-maple/STM32F1/system/libmaple/usb/usb_lib/usb_init.h" 1
# 29 "/Users/keith/.platformio/packages/framework-arduinoststm32-maple/STM32F1/system/libmaple/usb/usb_lib/usb_init.h"
void USB_Init(void);



extern u8 EPindex;




extern DEVICE_INFO* pInformation;


extern DEVICE_PROP* pProperty;




extern USER_STANDARD_REQUESTS *pUser_Standard_Requests;

extern u16 SaveState ;
extern u16 wInterrupt_Mask;
# 26 "/Users/keith/.platformio/packages/framework-arduinoststm32-maple/STM32F1/system/libmaple/usb/usb_lib/usb_lib.h" 2
# 1 "/Users/keith/.platformio/packages/framework-arduinoststm32-maple/STM32F1/system/libmaple/usb/usb_lib/usb_mem.h" 1
# 29 "/Users/keith/.platformio/packages/framework-arduinoststm32-maple/STM32F1/system/libmaple/usb/usb_lib/usb_mem.h"
void UserToPMABufferCopy(const u8 *pbUsrBuf, u16 wPMABufAddr, u16 wNBytes);
void PMAToUserBufferCopy(u8 *pbUsrBuf, u16 wPMABufAddr, u16 wNBytes);
# 27 "/Users/keith/.platformio/packages/framework-arduinoststm32-maple/STM32F1/system/libmaple/usb/usb_lib/usb_lib.h" 2
# 18 "/Users/keith/.platformio/packages/framework-arduinoststm32-maple/STM32F1/cores/maple/libmaple/usb/usb_lib/usb_mem.c" 2
# 35 "/Users/keith/.platformio/packages/framework-arduinoststm32-maple/STM32F1/cores/maple/libmaple/usb/usb_lib/usb_mem.c"
void UserToPMABufferCopy(const u8 *pbUsrBuf, u16 wPMABufAddr, u16 wNBytes)
{
  u32 n = (wNBytes + 1) >> 1;
  u32 i, temp1, temp2;
  u16 *pdwVal;
  pdwVal = (u16 *)(wPMABufAddr * 2 + (0x40006000L));
  for (i = n; i != 0; i--)
  {
    temp1 = (u16) * pbUsrBuf;
    pbUsrBuf++;
    temp2 = temp1 | (u16) * pbUsrBuf << 8;
    *pdwVal++ = temp2;
    pdwVal++;
    pbUsrBuf++;
  }
}
# 60 "/Users/keith/.platformio/packages/framework-arduinoststm32-maple/STM32F1/cores/maple/libmaple/usb/usb_lib/usb_mem.c"
void PMAToUserBufferCopy(u8 *pbUsrBuf, u16 wPMABufAddr, u16 wNBytes)
{
  u32 n = (wNBytes + 1) >> 1;
  u32 i;
  u32 *pdwVal;
  pdwVal = (u32 *)(wPMABufAddr * 2 + (0x40006000L));
  for (i = n; i != 0; i--)
  {
    *(u16*)pbUsrBuf++ = *pdwVal++;
    pbUsrBuf++;
  }
}
